<template>
  <div>
    <q-responsive :ratio="1" style="padding-bottom: 20px">
      <div v-if="config && config.visType === 'piechart'">
        <div class="pieContainer">
          <SpeakerPie :chartData="this.PieData" :options="chartOptions" />
        </div>
        <em class="text-center text-grey-6">Relative time speaking</em>
      </div>
      <div v-if="config && config.visType === 'network'" class="full-height">
        <div class="networkContainer full-height">
          <Network
            :networkdata="this.NetworkData"
            class="full-height"
          ></Network>
        </div>
      </div>

      <div v-if="config && config.visType === 'timeline'">
        <div class="timelineContainer">
          <Timeline :timelinedata="this.TimelineData"></Timeline>
        </div>
      </div>
    </q-responsive>
  </div>
</template>

<script>
import SpeakerPie from "./SpeakerPieBO";
import Timeline from "./TimelineBO";
import Network from "./NetworkBO";
import moment from "moment";
import { lookupRealHistory, getUniqueColorForString } from "./shared";
import { colors } from "quasar";

const { getPaletteColor } = colors;

export default {
  name: "RoomSpeakers",
  props: ["context", "firebase", "functions"],
  data() {
    return {
      config: { visType: "piechart" },
      activeSpeakers: { history: {}, current: {} },
      chartOptions: {
        responsive: true,
        hoverBorderWidth: 20,
        width: "100%",
        height: "100%",
        tooltips: {
          callbacks: {
            label: function (tooltipItem, data) {
              var label = data.labels[tooltipItem.index];
              if (label) {
                label += ": ";
              }
              label += moment
                .duration(
                  data.datasets[tooltipItem.datasetIndex].data[
                    tooltipItem.index
                  ],
                  "minutes"
                )
                .humanize();
              return label;
            },
          },
        },
        legend: {
          display: false,
          // maxHeight: 50,
        },
      },
    };
  },
  watch: {
    context: {
      immediate: true,
      async handler(context) {
        await this.$rtdbBind(
          "activeSpeakers",
          this.firebase
            .ref("data/activeSpeakers")
            .child(context.meetingid)
            .child(context.room)
        );

        // await this.$rtdbBind(
        //   "activeSpeakers",
        //   this.firebase
        //     .ref("data/activeSpeakers")
        //     .child(context.meetingid)
        //     .child(context.room),
        // );

        // console.log(this.activeSpeakers);

        await this.$rtdbBind(
          "config",
          this.firebase.ref(
            `config/${this.context.meetingid}/current/currentState/plugins/visualisation`
          )
        );
        // console.log(this.config);
        // if (typeof this.config.visType === "undefined")
        // this.config.visType = "piechart";
        // console.log(this.config);

        // this.firebaseloading = false;
      },
    },
    // },
  },
  computed: {
    // visType() {
    //   return this.config.visType || "piechart";
    // },
    // titleDisplay() {
    //   return this.title == ""
    //     ? `Breakout Room ${this.roomName.split("_")[1]}`
    //     : this.title;
    // },
    // isRecording() {
    //   return this.realhistory == 0 &&
    //     this.activeSpeakers &&
    //     this.activeSpeakers.current
    //     ? this.activeSpeakers.current.isRecording
    //     : false;
    // },
    // inBO() {
    //   if (
    //     this.activeSpeakers &&
    //     this.activeSpeakers.current &&
    //     (this.realhistory == 0 || this.realhistory == -1)
    //   )
    //     return this.activeSpeakers.current.isInBO;
    //   else {
    //     return this.history &&
    //       this.activeSpeakers &&
    //       this.activeSpeakers.history[this.realhistory]
    //       ? this.activeSpeakers.history[this.realhistory].isInBO
    //       : false;
    //   }
    // },
    // hasRecording() {
    //   const anonymous = this.$cookies.get("anonymous");
    //   if (anonymous) return false;

    //   return this.realhistory != 0 &&
    //     this.activeSpeakers.history[this.realhistory]
    //     ? this.activeSpeakers.history[this.realhistory].hasRecording
    //     : false;
    // },
    // finishTranscoding() {
    //   return this.realhistory != 0 &&
    //     this.activeSpeakers.history[this.realhistory]
    //     ? this.activeSpeakers.history[this.realhistory].finishTranscode
    //     : false;
    // },
    realhistory() {
      if (
        this.context &&
        this.context.history &&
        this.activeSpeakers &&
        this.activeSpeakers.history
      ) {
        return lookupRealHistory(
          this.context.history,
          this.activeSpeakers.history
        );
      } else {
        return 0;
      }
    },
    users() {
      let _ul = [];
      if (this.realhistory == 0) {
        if (this.activeSpeakers && this.activeSpeakers.current)
          _ul = this.activeSpeakers.current.userList;
      } else {
        if (this.realhistory != -1)
          _ul = this.activeSpeakers.history[this.realhistory].userList;
      }
      if (_ul == null) _ul = [];
      return _ul;
    },
    PieData() {
      try {
        var events = [];
        var live = false;
        var toRet = {
          labels: [],
          datasets: [
            {
              label: "Speaking time (mins)",
              backgroundColor: [],
              data: [],
            },
          ],
        };

        if (this.context.history == 0) {
          live = true;
          if (this.activeSpeakers.current)
            events = Object.values(this.activeSpeakers.current.activeHistory);
        } else if (
          this.activeSpeakers &&
          this.activeSpeakers.history &&
          this.activeSpeakers.history[this.realhistory]
        ) {
          events = Object.values(
            this.activeSpeakers.history[this.realhistory].activeHistory
          );
        } else {
          return toRet;
        }

        events.sort(this.CompareSpeakerTimeStamps);

        var userDict = {};

        if (events.length > 0) {
          var timestamp = new Date().getTime();

          for (var i = 0; i < events.length - 1; i++) {
            if (typeof events[i].zoomid == "number") {
              // For old style data (not an array)
              var uu = events[i].zoomid;
              if (!(uu in userDict)) {
                userDict[uu] = 0;
              }

              // If it is live data, only show the events from the last 5 minutes
              if (live) {
                if (timestamp - events[i].timestamp <= 5 * 60 * 1000)
                  userDict[uu] += events[i + 1].timestamp - events[i].timestamp;
              } else
                userDict[uu] += events[i + 1].timestamp - events[i].timestamp;
              continue;
            }

            if (Array.isArray(events[i].zoomid) && events[i].zoomid.length) {
              // For new style data (an array)
              for (var j = 0; j < events[i].zoomid.length; j++) {
                var thisUser = events[i].zoomid[j];
                // Not in dict already:
                if (!userDict[thisUser]) {
                  userDict[thisUser] = 0;
                }

                // If it is live data, only show the events from the last 5 minutes
                if (live) {
                  if (timestamp - events[i].timestamp <= 5 * 60 * 1000)
                    userDict[thisUser] +=
                      events[i + 1].timestamp - events[i].timestamp;
                } else
                  userDict[thisUser] +=
                    events[i + 1].timestamp - events[i].timestamp;
              }
            } else {
              // Silence:
              if (!userDict["__Silence"]) {
                userDict["__Silence"] = 0;
              }
              if (live) {
                if (timestamp - events[i].timestamp <= 5 * 60 * 1000)
                  userDict["__Silence"] +=
                    events[i + 1].timestamp - events[i].timestamp;
              } else
                userDict["__Silence"] +=
                  events[i + 1].timestamp - events[i].timestamp;
            }
          }

          // TODO update final speaker to be talking either until the present the end of the meeting
          // need end of meeting time for this
        }

        let names = Object.keys(userDict);

        names = names.sort((n, m) => {
          let a = this.users[n] ? this.users[n].username : "__Silence";
          let b = this.users[m] ? this.users[m].username : "__Silence";

          // Ensure silence will always be the last element
          if (a === "__Silence") return 1;
          if (b === "__Silence") return -1;

          if (a < b) return -1;
          if (a > b) return 1;

          return 0;
        });

        const addedColours = new Set();

        for (var zoomid of names) {
          let zoomName = this.users[zoomid]
            ? this.users[zoomid].username
            : "Silence";

          // Aggregate pie chart data by display name
          if (!toRet.labels.includes(zoomName)) {
            toRet.labels.push(zoomName);
            if (zoomName !== "Silence") {
              const color = getUniqueColorForString(zoomName, addedColours);
              addedColours.add(color);
              toRet.datasets[0].backgroundColor.push(getPaletteColor(color));
            }
            toRet.datasets[0].data.push(userDict[zoomid] / 1000 / 60);
          } else {
            let labelIndex = toRet.labels.indexOf(zoomName);
            toRet.datasets[0].data[labelIndex] += userDict[zoomid] / 1000 / 60;
          }
        }

        return toRet;
      } catch (e) {
        return toRet;
      }
    },
    NetworkData() {
      var events;
      var toRet;
      var live = false;
      var nodes = [];

      var edges = [
        { from: 2, to: 8, value: 3 },
        { from: 2, to: 9, value: 5 },
        { from: 2, to: 10, value: 1 },
        { from: 4, to: 6, value: 8 },
        { from: 5, to: 7, value: 2 },
        { from: 4, to: 5, value: 1 },
        { from: 9, to: 10, value: 2 },
        { from: 2, to: 3, value: 6 },
        { from: 3, to: 9, value: 4 },
        { from: 5, to: 3, value: 1 },
        { from: 2, to: 7, value: 4 },
      ];

      var options = {
        height: "100%",
        width: "100%",
        nodes: {
          shape: "dot",
          scaling: {
            customScalingFunction: function (min, max, total, value) {
              return value / total;
            },
            min: 5,
            max: 20,
          },
        },
        edges: {
          arrows: "to",
          scaling: {
            min: 1,
            max: 7,
          },
        },
        interaction: {
          zoomView: false,
          dragView: false,
        },
        layout: {
          improvedLayout: true,
        },
        physics: {
          solver: "forceAtlas2Based",
        },
      };

      try {
        let labelList = [];
        let idList = [];
        for (var g = 0; g < Object.keys(this.users).length; g++) {
          const labelName = this.users[Object.keys(this.users)[g]].username;
          if (!labelList.includes(labelName))
            nodes.push({
              id: Object.keys(this.users)[g],
              value: 1,
              label: labelName,
            });
          labelList.push(labelName);
          idList.push(Object.keys(this.users)[g]);
        }

        if (this.history == 0) {
          live = true;
          if (this.activeSpeakers.current)
            events = Object.values(this.activeSpeakers.current.activeHistory);
        } else if (
          this.activeSpeakers &&
          this.activeSpeakers.history &&
          this.activeSpeakers.history[this.realhistory]
        ) {
          events = Object.values(
            this.activeSpeakers.history[this.realhistory].activeHistory
          );
        } else {
          return toRet;
        }

        events.sort(this.CompareSpeakerTimeStamps);
        var links = {};
        var linkCount = 0;
        var lastUser = -1;

        if (events.length > 0) {
          var timestamp = new Date().getTime();

          for (var i = 0; i < events.length; i++) {
            if (events[i].zoomid) {
              if (!this.users[events[i].zoomid[0]]) continue;

              let eventUsername = this.users[events[i].zoomid[0]].username;
              let usernameIndex = labelList.indexOf(eventUsername);
              var uu = idList[usernameIndex];

              if (uu != lastUser) {
                if (linkCount != 0) {
                  var linkname = uu.toString() + lastUser.toString();
                  if (!links[linkname]) {
                    if (live) {
                      if (timestamp - events[i].timestamp <= 5 * 60 * 1000)
                        links[linkname] = { from: uu, to: lastUser, value: 1 };
                    } else
                      links[linkname] = { from: uu, to: lastUser, value: 1 };
                  } else {
                    var tempValue = links[linkname].value;
                    if (live) {
                      if (timestamp - events[i].timestamp <= 5 * 60 * 1000)
                        links[linkname].value = tempValue + 1;
                    } else links[linkname].value = tempValue + 1;
                  }
                }
                lastUser = uu;
                linkCount++;
              }
            }
          }
        }

        for (g = 0; g < Object.keys(links).length; g++) {
          edges.push(links[Object.keys(links)[g]]);
        }

        toRet = {
          nodes: nodes,
          edges: edges,
          options: options,
        };

        return toRet;
      } catch (e) {
        console.log(e);
        return toRet;
      }
    },
    TimelineData() {
      var events;
      var toRet;
      var live = false;
      var groups = [];
      var items = [];

      var options = {
        editable: false,
        stack: false,
        zoomable: false,
        cluster: true,
        verticalScroll: true,
        horizontalScroll: true,
        height: "250px",
        margin: 0,
        showMajorLabels: false,
        showMinorLabels: false,
        // timeAxis: {
        //   scale: "minute",
        //   step: 1,
        // },
      };

      try {
        let labelList = [];
        let idList = [];
        for (var g = 0; g < Object.keys(this.users).length; g++) {
          const labelName = this.users[Object.keys(this.users)[g]].username;
          if (!labelList.includes(labelName))
            groups.push({
              id: Object.keys(this.users)[g],
              content: labelName,
            });
          labelList.push(labelName);
          idList.push(Object.keys(this.users)[g]);
        }

        if (this.history == 0) {
          live = true;
          if (this.activeSpeakers.current)
            events = Object.values(this.activeSpeakers.current.activeHistory);
        } else if (
          this.activeSpeakers &&
          this.activeSpeakers.history &&
          this.activeSpeakers.history[this.realhistory]
        ) {
          events = Object.values(
            this.activeSpeakers.history[this.realhistory].activeHistory
          );
        } else {
          return toRet;
        }

        events.sort(this.CompareSpeakerTimeStamps);
        var currentSection;
        var section = 0;

        if (events.length > 0) {
          var timestamp = new Date().getTime();

          for (var i = 0; i < events.length; i++) {
            if (events[i].zoomid) {
              if (!this.users[events[i].zoomid[0]]) continue;

              let eventUsername = this.users[events[i].zoomid[0]].username;
              let usernameIndex = labelList.indexOf(eventUsername);
              var uu = idList[usernameIndex];

              if (section != 0) {
                currentSection.end = new Date(
                  events[i].timestamp
                ).toISOString();
                items.push(currentSection);
              }

              if (live) {
                if (timestamp - events[i].timestamp <= 5 * 60 * 1000) {
                  section++;
                  currentSection = {
                    id: section,
                    content: "",
                    start: new Date(events[i].timestamp).toISOString(),
                    end: null,
                    group: uu,
                  };
                }
              } else {
                section++;
                currentSection = {
                  id: section,
                  content: "",
                  start: new Date(events[i].timestamp).toISOString(),
                  end: null,
                  group: uu,
                };
              }
            }
          }
        }

        if (items.length !== 0) {
          toRet = {
            groups: groups,
            items: items,
            options: options,
          };
          return toRet;
        }
        return null;
      } catch (e) {
        console.log(e);
        return toRet;
      }
    },
  },
  methods: {
    CompareSpeakerTimeStamps(a, b) {
      return a.timestamp - b.timestamp;
    },
    // async recordingPath() {
    //   if (this.finishTranscoding) {
    //     let dirPath = `${this.user.uid}/${this.meeting[".key"]}/${this.activeSpeakers[".key"]}-${this.realhistory}`;
    //     console.log("Dir Path: ", dirPath);
    //     try {
    //       let path = `${dirPath}/meetingrec_0.mp4`;
    //       let pathReference = storage.ref(path);
    //       const url = await pathReference.getDownloadURL();
    //       let link = document.createElement("a");
    //       link.setAttribute("href", url);
    //       link.click();
    //     } catch (e) {
    //       console.error(e);
    //     }
    //   }
    // },
  },

  components: {
    SpeakerPie: SpeakerPie,
    Network: Network,
    Timeline: Timeline,
    // DocumentProgress: DocumentProgress,
  },
};
</script>

<style scoped>
.disabled {
  opacity: 0.1 !important;
}

/* .pieContainer {
  min-width: 33%;
  margin: auto;
} */

/* .timelineContainer {
  min-width: 33%;
  margin: auto;
} */

/* .networkContainer {
  min-width: 33%;
  margin: auto;
} */

.recording {
  background: rgba(255, 82, 82, 1);
  border-radius: 50%;
  margin: 10px;
  height: 10px;
  width: 10px;

  box-shadow: 0 0 0 0 rgba(255, 82, 82, 1);
  transform: scale(1);
  animation: pulse 2s infinite;
}

@keyframes pulse {
  0% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 rgba(255, 82, 82, 0.7);
  }

  70% {
    transform: scale(1);
    box-shadow: 0 0 0 10px rgba(255, 82, 82, 0);
  }

  100% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 rgba(255, 82, 82, 0);
  }
}

.pullright {
  float: right;
}
</style>
